# Release Notes

## v0.46.0 (December 8, 2025)

Highlights of this release include:

- Official support for Python 3.14.

- CMake IPO (Interprocedural Optimization) support.

- Fix for LLVM symbol visibility to prevent unwanted symbol export.

- Support for typed constants in debug info metadata.

- Improved error handling for FFI binding errors and missing CMake.

- Documentation for migrating from older llvmlite versions (<0.45).

Pull-Requests:

- PR #1309: Add docs for migrating from older llvmlite (<0.45) (sklam esc)

- PR #1311: GHA/ cleanup on python 3.14 official support (swap357)

- PR #1313: Merge pull request #1310 from esc/change-log-0.45.1 (esc)

- PR #1314: [FIX] Hide non-API symbols when CXX compiler supports GNUC style visibility controls to prevent LLVM symbol export and interposition (domcharrier)

- PR #1316: Prevent creating typed pointers of opaque pointers. (rj-jesus)

- PR #1317: Correct debug message text (eric-wieser)

- PR #1320: chore(deps): update dependency python to 3.14 (renovate[bot])

- PR #1321: Fix OptimizationLevel mapping for Os (yashssh)

- PR #1322: update release checklists (esc)

- PR #1323: Consolidate conda installs on azure environment setup script (swap357)

- PR #1325: fix llvmdev_for_wheel linux builds (swap357)

- PR #1326: [FEA] Add support for typed constant in debug info metadata emission. (jiel-nv)

- PR #1327: Update pre-commit hook rhysd/actionlint to v1.7.8 (renovate[bot])

- PR #1329: Update pre-commit hook python-jsonschema/check-jsonschema to v0.34.1 (renovate[bot])

- PR #1332: GHA/ fix llvmlite osx-arm64 wheel build tag (swap357)

- PR #1333: InlineAsm: fix formatting (gmarkall)

- PR #1334: CMake IPO support. (stuartarchibald tiran)

- PR #1335: Fix use of deprecated LLVM API. (stuartarchibald)

- PR #1336: Fix dummy CMake project. (stuartarchibald)

- PR #1339: chore(deps): update github artifact actions (major) (renovate[bot])

- PR #1340: fix syntax in docs (esc)

- PR #1341: fix/ remove ‘conda-remove-defaults’ option from setup-miniconda (swap357)

- PR #1345: gha/add upload_packages workflow (swap357)

- PR #1346: gha/ pin miniconda installers for manylinux builds (swap357)

- PR #1350: update license metadata (esc)

- PR #1353: chore(deps): update pre-commit hook pre-commit/mirrors-clang-format to v21.1.5 (renovate[bot])

- PR #1354: Improve error handling on FFI binding error (stuartarchibald)

- PR #1355: Improve error handling when CMake is not found. (stuartarchibald)

- PR #1358: Pin gcc/gxx to 11 (sklam)

- PR #1359: update macos image version from macos-13 to macos-15 on azure ci (swap357)

- PR #1360: chore(deps): update pre-commit hook python-jsonschema/check-jsonschema to v0.35.0 (renovate[bot])

- PR #1376: update changelog for 0.46.0 (swap357)

Authors:

- domcharrier

- eric-wieser

- esc

- gmarkall

- jiel-nv

- renovate[bot]

- rj-jesus

- sklam

- stuartarchibald

- swap357

- tiran

- yashssh

## v0.45.1 (October 01, 2025)

The is a patch release to fix an issue with Windows wheels.

Pull-Requests:

- PR #1307: GHA/win-64 add delvewheel repair to bundle `msvcp140.dll` (swap357)

- PR #1310: Change-log 0.45.1 (esc)

Authors:

- esc

- swap357

## v0.45.0 (Sept 17, 2025)

This release of llvmlite introduces support for LLVM 20. For more information about the state of the support and breaking changes, please see: https://llvmlite.readthedocs.io/en/latest/user-guide/llvm20.html

Pull-Requests:

- PR #1091: [NPM] Add hooks for llvm passes in llvmlite (gmarkall yashssh)

- PR #1092: Move llvmlite to LLVM 20 (sklam swap357 yashssh esc)

- PR #1096: Added changelog for 0.44.0rc1 (kc611)

- PR #1101: Updated date and llvm versioning for 0.44.0rc1 (kc611)

- PR #1112: adding bullet to first RC checklist regarding LLVM updates (esc)

- PR #1113: Merge pull request #1104 from sklam/misc/osx_wheel_fix (kc611 esc)

- PR #1114: Merge pull request #1108 from sklam/fix/win_wheel (kc611 esc)

- PR #1115: Update changelog for v0.44.0rc2 (kc611)

- PR #1124: Changed version number and release date (kc611)

- PR #1125: Fix flag condition when creating SimpleLoopUnswitchLegacyPass (HighW4y2H3ll)

- PR #1128: Adding llvmdev win 64 conda builder (esc)

- PR #1129: llvmlite win-64 conda builder GHA (esc)

- PR #1130: Configure Renovate (renovate[bot] esc)

- PR #1131: llvmdev_linux-64_conda_builder.yml (esc)

- PR #1132: llvmlite_linux-64_conda_builder.yml (esc)

- PR #1133: Cherry-pick changes to the CHANGE_LOG to main (kc611)

- PR #1139: Add win-64 wheel builder GHA workflow (dbast swap357 esc)

- PR #1141: refactor llvmdev win builder (swap357)

- PR #1142: point conda build to correct package path (esc)

- PR #1143: remove release.yml – it’s stale and outdated (esc)

- PR #1144: Refactor recipe build flows (dbast)

- PR #1146: Extend pre-commit config (dbast)

- PR #1148: Update pre-commit hook pre-commit/mirrors-clang-format to v19 (renovate[bot])

- PR #1149: Rename llvmdev manylinux (esc)

- PR #1150: enable running workflow as part of pull-request (esc)

- PR #1151: fix flake8 issues (esc)

- PR #1152: adding pre-commit workflow (esc)

- PR #1154: execute dist tests for linux-64 conda pkgs via Azure (esc)

- PR #1156: Enable Github Action pinning via renovate (dbast)

- PR #1157: Update pre-commit hook PyCQA/flake8 to v7.1.2 (renovate[bot])

- PR #1158: Opaque pointer fixes (rj-jesus gmarkall)

- PR #1159: Add IR layer typed pointers mode (rj-jesus gmarkall)

- PR #1160: Drop binding layer typed pointer support. (rj-jesus)

- PR #1161: Update pre-commit hook python-jsonschema/check-jsonschema to v0.31.3 (renovate[bot])

- PR #1163: Enable pass timings reporting with NewPassManager (gmarkall yashssh)

- PR #1165: Fix the metadata deduplication (jiel-nv)

- PR #1169: Update pre-commit hook pre-commit/mirrors-clang-format to v20 (renovate[bot])

- PR #1171: Pin dependencies (renovate[bot])

- PR #1172: Update actions/checkout action to v4.2.2 (renovate[bot])

- PR #1173: Update actions/download-artifact action to v4.1.9 (renovate[bot])

- PR #1174: Update actions/setup-python action to v5.4.0 (renovate[bot])

- PR #1175: Update actions/upload-artifact action to v4.6.2 (renovate[bot])

- PR #1176: Update conda-incubator/setup-miniconda action to v3.1.1 (renovate[bot])

- PR #1177: fix typo in workflow options for llvmdev_build.yml (swap357)

- PR #1178: Update actions/download-artifact action to v4.2.1 (renovate[bot])

- PR #1180: Update actions/setup-python action to v5.5.0 (renovate[bot])

- PR #1181: Update pre-commit hook python-jsonschema/check-jsonschema to v0.32.1 (renovate[bot])

- PR #1185: Update pre-commit hook PyCQA/flake8 to v7.2.0 (renovate[bot])

- PR #1187: gha/add llvmlite osx 64 wheel builder (swap357)

- PR #1188: bump min CMake (esc)

- PR #1189: bump Ubuntu to 24.04 (esc)

- PR #1190: gha/add llvmlite osx 64 conda builder (swap357)

- PR #1193: Update pre-commit hook python-jsonschema/check-jsonschema to v0.33.0 (renovate[bot])

- PR #1195: gha/add llvmlite osx-arm64 conda builder (swap357)

- PR #1196: Pin dependencies (renovate[bot])

- PR #1197: Update actions/checkout action to v4.2.2 (renovate[bot])

- PR #1198: Update actions/download-artifact action to v4.3.0 (renovate[bot])

- PR #1199: Update actions/setup-python action to v5.6.0 (renovate[bot])

- PR #1200: Update actions/upload-artifact action to v4.6.2 (renovate[bot])

- PR #1201: Update conda-incubator/setup-miniconda action to v3.1.1 (renovate[bot])

- PR #1203: gha/add llvmlite osx-arm64 wheel builder workflow (swap357)

- PR #1205: gha/add llvmlite_linux-64 wheel builder workflow (swap357)

- PR #1206: gha/add llvmlite linux-arm64 wheel builder (swap357)

- PR #1209: remove singular clang-format check based on ubuntu/apt (esc)

- PR #1210: Update pre-commit hook pre-commit/mirrors-clang-format to v20.1.4 (renovate[bot])

- PR #1211: gha/fix llvmlite linux workflows for version tags (swap357)

- PR #1213: unify clang format check (esc)

- PR #1215: gha/add llvmlite linux-arm64 conda builder (swap357)

- PR #1216: gha/refactor llvmlite osx wheel workflows (swap357)

- PR #1217: gha/refactor llvmlite win-64 workflows (swap357)

- PR #1218: Pin conda-incubator/setup-miniconda action to 505e639 (renovate[bot])

- PR #1219: Update actions/checkout action to v4.2.2 (renovate[bot])

- PR #1220: Update actions/download-artifact action to v4.3.0 (renovate[bot])

- PR #1221: Update actions/upload-artifact action to v4.6.2 (renovate[bot])

- PR #1222: Update conda-incubator/setup-miniconda action to v3.1.1 (renovate[bot])

- PR #1223: fix/revert gha recipe changes (swap357)

- PR #1224: Update pre-commit hook pre-commit/mirrors-clang-format to v20.1.8 (renovate[bot])

- PR #1226: [WIP] LLVM 20 llvmdev recipe (gmarkall swap357 esc)

- PR #1227: fix llvmdev_build.yml to resolve toolchain incompatibility on osx-64 (swap357)

- PR #1228: Update conda-incubator/setup-miniconda action to v3.2.0 (renovate[bot])

- PR #1231: azure-pipelines/win-2019 to 2025 (swap357)

- PR #1232: gha/llvmdev upgrade win-2019 to 2025 (swap357)

- PR #1233: gha/llvmlite upgrade win-2019 to 2025 (swap357)

- PR #1235: Update pre-commit hook PyCQA/flake8 to v7.3.0 (renovate[bot])

- PR #1236: Update pre-commit hook python-jsonschema/check-jsonschema to v0.33.1 (renovate[bot])

- PR #1238: gha/restructure llvmdev ci (swap357)

- PR #1239: Update pre-commit hook python-jsonschema/check-jsonschema to v0.33.2 (renovate[bot])

- PR #1240: pin compilers on llvmlite and llvmdev conda_build_config.yaml (swap357)

- PR #1241: gha/llvmlite wheel workflow fixes (swap357)

- PR #1242: gha/unify llvmlite conda builder workflows (swap357)

- PR #1245: set CONDA_PLUGINS_AUTO_ACCEPT_TOS to manylinux env setup script (swap357)

- PR #1246: gha/fix artifact usage manylinux wheels (swap357)

- PR #1248: Update actions/download-artifact action to v5 (renovate[bot])

- PR #1249: gha/update PR path triggers to include conda recipes (swap357)

- PR #1250: Fix pass timing logic to stop printing to stdout. (stuartarchibald)

- PR #1251: Fix various C++ issues and a linkage issue. (stuartarchibald)

- PR #1252: Move llvmlite to solely CMake based build system. (stuartarchibald)

- PR #1253: Update pre-commit hook pre-commit/pre-commit-hooks to v6 (renovate[bot])

- PR #1256: Update actions/checkout action to v5 (renovate[bot])

- PR #1257: remove code climate integration (esc)

- PR #1258: Update pre-commit hook python-jsonschema/check-jsonschema to v0.33.3 (renovate[bot])

- PR #1259: update osx-64 sdk on recipes and CI scripts to use MacOSX10.15 SDK (swap357)

- PR #1260: llvmdev 20 build patches (swap357)

- PR #1262: llvmdev-20 recipe fixes (swap357)

- PR #1266: update compatability matrix in the README.rst to reflect LLVM 20 (esc)

- PR #1267: adding llvm20 docs (esc)

- PR #1268: Release 0.45: CHANGE_LOG (esc)

- PR #1269: add sdist build and upload steps on wheel workflow (swap357)

- PR #1274: GHA/ standardize job names on workflows for linux builds (swap357)

- PR #1276: Fix build-string on llvmdev_for_wheels conda recipe (swap357)

- PR #1278: Update deprecation page (sklam)

- PR #1287: change-log for 0.45.0 FINAL (esc)

- PR #1289: use explicit channel specification for llvmdev=20 installation (swap357 esc)

Authors:

- alexander-shaposhnikov

- dbast

- esc

- gmarkall

- HighW4y2H3ll

- jiel-nv

- kc611

- renovate[bot]

- rj-jesus

- sklam

- stuartarchibald

- swap357

- yashssh

## v0.44.0 (16 January, 2025)

Highlights of this release are:

- Official support for Python 3.13.

- Dropped official support for Python 3.9, the minimum supported Python version is 3.10.

- LLVM 15 is now the default LLVM.

- Added support for LLVM’s new PassManager.

- Support for LLVM based target triple partitioning.

- `llvmlite.binding.TypeRef` now roundtrips back into `llvmlite.ir.Type`.

- API updates to accommodate packed Literal Structs.

- Added NetBSD support.

- Support for opaque pointers.

Pull-Requests:

- PR #1036: LLVM 15 conda recipe (sklam gmarkall)

- PR #1046: Add basic infra required to move Numba to NewPassManager (yashssh gmarkall)

- PR #1050: Add conda-forge pre-tag testing to release checklist (gmarkall)

- PR #1051: Roundtrip llvmlite.binding.TypeRef back into llvmlite.ir.Type (sklam)

- PR #1053: Use RTD for all docs CI / testing (was: Try and get CI to use a newer Sphinx) (gmarkall)

- PR #1057: Port refprune pass to NewPassManager (yashssh)

- PR #1060: port changelog for 0.43.0 to main (esc)

- PR #1063: Added llvm based process triple partitioning (kc611)

- PR #1064: Add support for opaque pointers (gmarkall rj-jesus)

- PR #1066: Move Azure to use macos-12 (gmarkall)

- PR #1067: Use LLVM 15 by default, add experimental LLVM 16 support (gmarkall)

- PR #1068: Early exit from fpm.run() if called on function declarations (yashssh)

- PR #1069: Add instrumentation callback hook for new pass managers (yashssh)

- PR #1073: bump compiler for linux-aarch64 to 11 (esc)

- PR #1077: Add NetBSD support. (0-wiz-0)

- PR #1080: Added Python 3.13 to CI and Descriptions (kc611)

- PR #1081: Add convenience func and args (thomaspinckney3)

- PR #1085: Fix RTD build, no need for get_html_theme_path(). (stuartarchibald)

- PR #1087: Add missing argtypes description for refprune pass related APIs (yashssh)

- PR #1090: Add MSVC -GL workaround (sklam)

- PR #1094: Fix CI by not removing nonexistent environment (gmarkall)

- PR #1097: update azure-pipelines to macos-13 (swap357)

- PR #1098: Fix store to opaque ptr (alexander-shaposhnikov)

- PR #1104: Target 0.44.0: Fix osx wheel build (sklam)

- PR #1108: Fix Windows llvmdev build due to zlib linkage (sklam)

Authors:

- 0-wiz-0

- esc

- gmarkall

- kc611

- rj-jesus

- sklam

- stuartarchibald

- thomaspinckney3

- yashssh

- alexander-shaposhnikov

- swap357

## v0.43.0 (June 13, 2024)

Highlights of this release are:

- Support for building against LLVM 15.

- A fix for refpruning algorithm in specific fanout_raise cases.

Pull-Requests:

- PR #1025: skip raise basic blocks in verifyFanoutBackward (dlee992)

- PR #1029: Update CHANGE_LOG for 0.42.0 final. (stuartarchibald)

- PR #1032: v0.42 Post release (sklam)

- PR #1035: Support building against llvm15 (gmarkall yashssh)

- PR #1059: update CHANGE_LOG and release date for 0.43.0 final (esc)

Authors:

- dlee992

- esc

- gmarkall

- sklam

- stuartarchibald

- yashssh

## v0.42.0 (January 31, 2024)

Highlights of this release include:

- Support for Python 3.12.

- A fix for relocation overflows on AArch64 systems.

- Binding layer: new queries for incoming blocks of phi instructions, type kinds, and elements. Addition of the Instruction Namer pass.

- IR layer: Support convergent as an attribute of function calls and call instructions.

Pull-Requests:

- PR #973: Bindings: Query incoming blocks of a phi instruction (tbennun)

- PR #978: Bindings: Query type kinds, derived types, and elements (tbennun sklam)

- PR #981: Add Instruction Namer pass to PassManager (tbennun)

- PR #993: Update changelog on main for 0.41.0 (esc)

- PR #1005: Remove suggestion that add_global_mapping() is unused (gmarkall)

- PR #1006: Release Notes 0.41.1 for main (esc)

- PR #1007: update release checklists post 0.41.1 (esc)

- PR #1009: Fix relocation overflows by implementing preallocation in the memory manager (gmarkall)

- PR #1010: Python 3.12 (esc)

- PR #1012: conda-recipe cleanups (esc)

- PR #1014: Fix conda-recipe syntax errors from #1012 (esc)

- PR #1017: add 3.12 to azure (esc)

- PR #1018: Bump minimum supported Python version to 3.9 (kc611)

- PR #1019: Add convergent as a supported FunctionAttribute and CallInstrAttribute. (diptorupd)

Authors:

- diptorupd

- esc

- gmarkall

- kc611

- sklam

- tbennun

## v0.41.1 (October 17, 2023)

This is a maintenance release that includes a workaround in the test suite for ORCJit issues on the `aarch64` platform. Also, this is the last release to support the Windows 32-bit platform (`win32`).

Pull-Requests:

- PR #996: fix typos found by codespell (esc)

- PR #997: Fix issue #880 by ensuring all sources are compiled under FreeBSD. (ke6jjj)

- PR #998: adding sphinx_rtd_theme to RTD build to fix build (esc)

- PR #1001: Fix / workaround for OrcJIT blocking issues (gmarkall)

Authors:

- esc

- ke6jjj

- gmarkall

## v0.41.0 (September 20, 2023)

Pull-Requests:

- PR #871: Refactor native library loading (folded sklam)

- PR #896: drop upper limit on Python for conda recipe (esc)

- PR #904: Create GitHub Action for llvmlite release (apmasell)

- PR #934: Expose TargetLibraryInfo pass (sklam)

- PR #935: Disable zlib for LLVM on Windows (apmasell)

- PR #936: Enable querying constants and value kinds (tbennun)

- PR #939: Bump llvmdev build number to include the nozlib change for windows (sklam)

- PR #940: Update CHANGE_LOG for 0.40.0 final. (stuartarchibald)

- PR #942: Add ORCJITv2 support (apmasell)

- PR #951: Add a type hint for IntType.width (apmasell)

- PR #952: Fix CI failing due to unsupported target triple on non-x86 platforms. (sklam)

- PR #958: fixup LLVM versions in version compat table (esc)

- PR #959: Remove support for LLVM < 14 (apmasell)

- PR #960: add various bullets to release checklists and sync (esc)

- PR #963: Allow adding comments to generated IR (apmasell)

- PR #966: build: support building on GNU/Hurd (pinotree)

- PR #967: Expose library name in OrcJIT tracker (apmasell)

- PR #968: Update LLVM manual build instructions (apmasell)

- PR #969: update changelog on main for v0.40.1 (esc)

- PR #983: adding RTD conf file V2 as per request (esc)

- PR #985: Update release checklist post 0.41.0rc1 (esc)

- PR #988: Fix FreeBsd build (sklam)

Authors:

- apmasell

- esc

- folded

- pinotree

- sklam

- stuartarchibald

- tbennun

## v0.40.1 (June 21, 2023)

Pull-Requests:

- PR #945: Fix #944. Add .argtypes to prevent errors in pypy. (Siu Kwan Lam)

- PR #947: Update SVML patch for LLVM 14 (Andre Masella)

- PR #949: Handle PowerPC synonyms (Andre Masella)

- PR #950: Fix incorrect byval and other attributes on LLVM 14 (Andre Masella)

Authors:

- Andre Masella

- Siu Kwan Lam

## v0.40.0 (May 1, 2023)

This release predominantly upgrades to LLVM 14 and Python 3.11. Bindings to a large number of passes are added. The minimum supported Python version is now Python 3.8.

Note: A bug was discovered in LLVM’s RuntimeDyldELF on the Aarch64 platform that can cause segfaults when cross module symbols are linked. It is necessary for JIT users to build LLVM with the patch added in PR#926.

Pull-Requests:

- PR #827: Add more LLVM pass bindings (apmasell)

- PR #830: Add LLVM 14 support (apmasell)

- PR #860: the git tag for the RC needs an rc1 suffix (esc)

- PR #869: bump max Python version to 3.11 (esc sklam)

- PR #876: Remove `llvmlite.llvmpy` after deprecation (apmasell)

- PR #883: Adds support for calling functions with ‘tail’, ‘notail’, or ‘musttail’ markers. (bslatkin)

- PR #886: Simplify setup.py Python version guard (mbargull)

- PR #892: Bump minimum supported Python version to 3.8 (jamesobutler)

- PR #893: Upgrade to ubuntu-20.04 for azure pipeline CI (jamesobutler)

- PR #899: Run Minconda install with bash (gmarkall)

- PR #903: Fix flake8 config and style for flake8 6 (gmarkall)

- PR #905: Add YouCompleteMe configuration file and ignore vim swap files (gmarkall)

- PR #906: Replace importlib-resources legacy API use (sklam)

- PR #910: Aarch64 split build for LLVM14 (sklam)

- PR #921: Setup AzureCI to use py311 and llvm14 (sklam)

- PR #922: Fix AzureCI not using llvm14 on windows (sklam)

- PR #926: llvmdev recipe: Add patch that clears GOTOffsetMap (apmasell gmarkall sklam)

- PR #930: Update changelog for 0.40.0rc1 (sklam stuartarchibald)

- PR #931: Remove maximum Python version limit (sklam apmasell)

- PR #932: Fix wheel builds (sklam)

- PR #935: Disable zlib for LLVM on Windows (apmasell)

- PR #939: Bump llvmdev build number to include the nozlib change for windows (sklam)

- PR #940: Update CHANGE_LOG for 0.40.0 final. (stuartarchibald)

Authors:

- apmasell

- bslatkin

- esc

- gmarkall

- jamesobutler

- mbargull

- sklam

- stuartarchibald

## v0.39.1 (September 1, 2022)

This is a maintenance release to fix build issues on MacOS.

Pull-Requests:

- PR #752: Skip test if libm is not found (Siu Kwan Lam)

- PR #865: Move Azure to use macos-11 (stuartarchibald)

- PR #874: Add zlib as a dependency for aarch64 (esc)

- PR #878: Update changelog (Andre Masella)

## v0.39.0 (July 25, 2022)

This release predominantly adds new features and improves functionality.

- It’s now possible to directly set LLVM `metadata` on global variables.

- Functions and global variables now support the specification of a `section` in which they should be placed.

- The attribute `source_file` had been added to the `ModuleRef` class, it returns the module’s original file name.

- The FFI library binding to LLVM is now loaded with `importlib` to increase compatibility with other projects and improve start-up times.

- Linux builds now use the parallel option to `make` to speed up building the FFI library.

- Preliminary work to expose LLVM’s optimization-remarks interface has been undertaken. The bindings are exposed and tested, but not yet documented for general use (additional work is needed).

Deprecations:

- The `llvmlite.llvmpy` module has been deprecated as the functionality it provides is available through the `llvmlite.ir` module. See the deprecation guide in the user documentation for details and recommendations regarding replacement.

Pull-Requests:

- PR #328: Build C files separately on Linux and support parallel make (Michał Górny)

- PR #754: manylinux2014 aarch64 wheels with system compilers (esc)

- PR #760: add support for attaching metadata to global variables (Graham Markall John Törnblom)

- PR #786: Update Windows and OSX CI images. (stuartarchibald)

- PR #801: Update ffi.py (franzhaas)

- PR #803: llvm::Module::GetSourceFileName (J. Aaron Pendergrass)

- PR #806: Bump to v0.39.0dev (esc)

- PR #807: Exclude ExecutionEngine tests on linux 32 (esc)

- PR #809: Update CHANGE_LOG for 0.38.0 (stuartarchibald)

- PR #813: Add m1 support to conda build scripts (esc Stan Seibert)

- PR #815: update local references (esc)

- PR #816: remove configuration landscape service as it is no longer used (esc)

- PR #817: remove uppper limit on Python requires (esc)

- PR #819: adding rc and final release checklist templates (esc)

- PR #823: Add section to globals (Andreas Wrisley)

- PR #824: add GitHub URL for PyPi (Andrii Oriekhov)

- PR #825: Add flag handling to more instructions. (stuartarchibald Andre Masella)

- PR #826: Deprecated llvmlite.llvmpy (Andre Masella)

- PR #831: Format C++ code (Andre Masella)

- PR #832: DOC: Fix the syntax for the llvmlite discourse topic link. (stuartarchibald)

- PR #835: Add pre-commit hooks for clang-format (Andre Masella)

- PR #837: Add support for optimization remarks in pass managers (Siu Kwan Lam Andre Masella)

- PR #846: Cherry-Pick: #842 –> main :Changelog for 0.38.1 (esc)

- PR #851: adding the llvm_11_consecutive_registers.patch (esc)

- PR #857: Delegate passmanager remarks methods (Andre Masella)

- PR #858: Update CHANGE_LOG for 0.39.0 (esc Graham Markall stuartarchibald)

- PR #863: Update changelog for 0.39.0 release (Siu Kwan Lam)

- PR #864: Update release date for 0.39.0 release. (stuartarchibald)

- PR #867: Update CHANGE_LOG 0.39.0 final. (stuartarchibald)

Authors:

- Andrii Oriekhov

- Andreas Wrisley

- Andre Masella

- esc

- franzhaas

- Graham Markall

- J. Aaron Pendergrass

- John Törnblom

- Michał Górny

- Stan Seibert

- Siu Kwan Lam

- stuartarchibald

## v0.38.1 (May 19, 2022)

This is a maintenance release to support the Apple M1 architecture.

Pull-Requests:

- PR #841: Merge pull request #813 from seibert/m1_support (esc, Stan Seibert)

- PR #845: Backport #786 for 0.38.1 (stuartarchibald)

Authors:

- esc

- Stan Seibert

- stuartarchibald

## v0.38.0 (January 13, 2022)

This release makes llvmlite compatible with Python 3.10. It also adds an `abiname` option to the target machine creation interface that mimics the same in LLVM. Further, a large number of functions are added to the IR API to support common uses of constant expressions. Finally, a number of bugs were fixed!

Pull-Requests:

- PR #702: Implement minimal support for call-site argument attributes (David Nadlinger)

- PR #739: Bump to 0.38.0 development series (Siu Kwan Lam)

- PR #751: Fix encoding of unicode string in metadata. (Siu Kwan Lam)

- PR #757: Add issue templates based on those in Numba (Graham Markall)

- PR #763: Update the Azure default linux image to Ubuntu 18.04 (stuartarchibald)

- PR #769: Python 3.10 (esc)

- PR #771: cleanup llvmlite metadata (esc)

- PR #774: Fix OSX breakage on master (esc)

- PR #775: targets.py: Add ABIName parameter for RISC-V hard float targets (Graham Markall occheung)

- PR #778: fix: test code typo (Itmom)

- PR #779: pin compiler toolchain to version 10 on osx (esc)

- PR #784: Adds _ConstOpMixin.ptrtoint to complement existing bitcast and inttoptr methods. (Brett Slatkin)

- PR #788: Add RISC-V + all default targets to LLVM build (Stan Seibert esc)

- PR #789: don’t build docs on every platform, only once (esc)

- PR #791: update to use LLVM 11.1.0 build 4 (esc)

- PR #795: Continue PR #735 (Add support for more constant expressions) (Graham Markall John Törnblom)

- PR #797: Make tests that require cross compilation to RISCV optional. (stuartarchibald)

Authors:

- Itmom

- Brett Slatkin

- David Nadlinger

- esc

- Graham Markall

- John Törnblom

- occheung

- Stan Seibert

- Siu Kwan Lam

- stuartarchibald

## v0.37.0 (August 19, 2021)

The biggest new feature in this release is LLVM 11 support for all platforms! This is important, because the `aarch64` platform had been ‘stuck’ on LLVM 9 for several releases. A special thanks to David Spickett from Linaro for supplying the relevant patch.

Pull-Requests:

- PR #711: Use conda for readthedocs with Python 3.9 (Antoine Pitrou esc)

- PR #715: LLVM 11.1.0 (Ivan Butygin esc)

- PR #726: Disallow alwaysinline and noinline on functions (Graham Markall)

- PR #730: Don’t export LLVM symbols when linking statically (Chris Burr esc)

- PR #732: Docs/remove travis (esc)

- PR #734: bump llvmdev to 11 (esc)

- PR #736: manylinux llvmdev upgrade to LLVM 11 / manylinux2010 to manylinux2014 upgrade (esc)

- PR #747: Remove 3.6 Support (esc)

- PR #748: Fixup readme (esc)

- PR #749: adding PRs specific to the RC2 release (esc)

- PR #762: PR #758 continued. Ensure GCC7 is used on non-ARM platforms. (esc stuartarchibald)

- PR #764: Update CHANGE_LOG for 0.37.0 (stuartarchibald)

Authors:

- Ivan Butygin

- Chris Burr

- esc

- Graham Markall

- Antoine Pitrou

- Siu Kwan Lam

- stuartarchibald

## v0.36.0 (March 11, 2021)

The main feature in this release is Python 3.9 support. Also, some changes to the build scripts were included: the llvmdev recipe now supports compilation on Windows 10 and llvmlite may now be compiled with cmake on POSIX systems. Additionally, both the timings from the LLVM passes themselves and the time spent within the LLVM thread-safe access lock are now available for diagnostic purposes. Lastly, several minor cosmetic changes to the documentation and project files are included.

Pull requests:

- PR #624: Expose pass timings

- PR #655: Switch encoding to UTF-8 from latin1

- PR #662: Delete `requirements.txt`

- PR #666: fix rst syntax in install docs

- PR #668: Modify cmake options to work with VS2019

- PR #670: Llvmdev windows 10

- PR #671: Python 3.9 support

- PR #673: use build 2 on windows

- PR #677: Support building with CMake on posix systems

- PR #682: slight rearrangement of intro

- PR #685: Added fneg instruction

- PR #687: Cleanup public CI configuration and badge

- PR #689: fixup azure badge to point at master branch

- PR #690: Callback to track when the llvm lock is acquired and released

- PR #699: adapt Python version clamp from Numba

- PR #701: Improve llvm not found error

Authors:

- Graham Markall

- John Kirkham

- Peter-Jan Gootzen

- Siu Kwan Lam (core dev)

- Stan Seibert (core dev)

- Stuart Archibald (core dev)

- Uwe L. Korn

- Valentin Haenel (core dev)

- `@ARF1`

- `@abebeos`

- `@0x5h4un`

## v0.35.0 (November 30, 2020)

The main feature in this release is a Numba specific LLVM pass for pruning reference-count operations. We plan to generalize this custom LLVM pass once it is proven stable so that it can be configured for other uses. In addition, this release contains an updated SVML patch that fixes an issue for AVX512, and a patch that fixes build issues on Linux and BSD.

Pull requests:

- PR #617: Fix wheel building.

- PR #618: Fix changelog on master

- PR #626: Update SVML patch

- PR #627: Always build with -fPIC on Linux and BSD

- PR #633: Fix Issue #632 - obj file section contents truncated

- PR #634: Implement reference count pruner LLVM pass

- PR #635: Fixes #629: Default to 0 if None is passed as a value for Int32

- PR #637: Fix appveyor

- PR #640: Backport llvm refop pass for LLVM 9.

- PR #641: fix llvmdev build number

- PR #642: pin to correct version of llvmdev

- PR #644: Fix refprune fanout_raise case getting stuck on large graphs

- PR #647: Add support for general attrs on call and loop-rotate pass

Authors:

- Graham Markall

- Ivan Butygin

- NavyaZaveri

- Siu Kwan Lam (core dev)

- Stuart Archibald (core dev)

- Valentin Haenel (core dev)

## v0.34.0 (August 12, 2020)

This release upgrades to LLVM 10 (10.0.1) for all platforms except aarch64 which will remain at LLVM 9 (9.0.1).

Pull requests:

- PR #596: Use std::make_unique on LLVM 10 (Cherry-Pick via #599)

- PR #606: Revert “Fix CUDA with LLVM9” (Cherry-Pick via #599)

- PR #599: LLVM 10

- PR #598: Fix flake in setup.py

- PR #602: add missing targets to wheels

- PR #614: Fix wheel building

- PR #616: fix release date in changelog

Authors:

- Graham Markall

- Michał Górny

- Siu Kwan Lam (core dev)

- Stuart Archibald (core dev)

- Valentin Haenel (core dev)

## v0.33.0 (June 10, 2020)

This release upgrades to LLVM 9 and drops support for older LLVM versions.

Pull requests:

- PR #593: Fix CUDA with LLVM9

- PR #592: Fix meta.yaml

- PR #591: buildscripts: Unpin wheel

- PR #590: add python_requires to setup.py

- PR #582: Adds override for LLVM version check, re-formats docs.

- PR #581: Add FAQ entry on LLVM version support.

- PR #580: Trove classifiers may be out of date.

- PR #577: llvmlite wheel building fixes

- PR #575: Update the release date

- PR #548: Upgrade to LLVM9

- PR #521: Allow instructions to be removed from blocks

Authors:

- Graham Markall

- Jan Vesely

- Siu Kwan Lam (core dev)

- Stuart Archibald (core dev)

- Tim Babb

- Valentin Haenel (core dev)

## v0.32.1 (May 7, 2020)

This is a small patch release that addresses some packaging issues:

Pull requests:

- PR 580: Trove classifiers may be out of date.

- PR 581: Add FAQ entry on LLVM version support.

- PR 582: Adds override for LLVM version check, re-formats docs.

Authors:

- Stuart Archibald (core dev)

- Valentin Haenel (core dev)

## v0.32.0 (Apr 16, 2020)

The main changes in this release are the removal of specific code for Python 2 and Python <3.6, and making the code base PEP8 compliant.

Pull requests:

- PR #577: llvmlite wheel building fixes

- PR #560: ENH: Better error message

- PR #558: update install docs

- PR #556: binding: Allow empty features list

- PR #555: travis: Cleanup

- PR #554: azure-pipelines: Bump VM images.

- PR #552: Add paragraph on installing from sdist and on non-traditional platforms.

- PR #551: Remove python 2, python < 3.6, fix up, add flake8

- PR #549: Miscalled method and missing parameter in the documentation

- PR #547: Permit building on Visual Studio 2017

- PR #543: Update error message in LLVM version check.

- PR #540: update to final release date for 0.31.0

Authors:

- Arik Funke

- Eric Larson

- Jan Vesely

- Shan Sikdar

- Siu Kwan Lam (core dev)

- Stan Seibert (core dev)

- Stuart Archibald (core dev)

- Vladislav Hrčka

## v0.31.0 (Jan 2, 2020)

This release switches memset/memcpy to use the 4 argument style as per LLVM 7+ and updates some documentation.

Commits:

- PR #485: Revert “Revert “LLVM 7 changed memset intrinsic signature, adjust it””

- PR #520: Begin development of 0.31.0

- PR #528: Add cttz and ctlz to irbuilder docs.

- PR #533: Update deprecation docs with full deprecation of 5 arg memset/memcpy

- PR #535: Update docs to not report LLVM 3.8 as latest!

Authors:

- Isaac Virshup

- Siu Kwan Lam (core dev)

- Stuart Archibald (core dev)

## v0.30.0 (Oct 9, 2019)

This release adds support for half-precision float and schedules the deprecation of memset/memcpy accepting 5 arguments (cf. LLVM change).

- PR #518: Fix use of -fPIC flag in wheels

- PR #513: Remove restriction on sphinx version from Anaconda distro

- PR #512: fix for block labels which contain “interesting” characters

- PR #511: Deprecate the use of memset/memcpy with alias

- PR #510: Add fp16 Intrinsics

- PR #509: Add Half-Precision Type

- PR #502: Add -fPIC flag for manylinux1 wheel building

- PR #491: Fix incorrect hierarchy in the documentation for ir.Constant.

- PR #474: Update docs

- PR #470: Fix leak on string returning APIs.

## v0.29.0 (May 29, 2019)

This release upgrades to LLVM 8.0 for all supported platforms except PPC64LE. Due to numerous problems with LLVM 8.0 running on PPC64LE, we have decided to use LLVM 7.1, which is more stable on PPC64LE. In addition, non-host LLVM targets, AMDGPU, NVPTX, and WebAssembly, are enabled and they are available in our llvmlite builds.

- PR #484: Revert “LLVM 7 changed memset intrinsic signature, adjust it”

- PR #483: Depend on enum34 using PEP 508 environment markers

- PR #478: Upgrade to llvm8

- PR #469: Support loading from current directory and egg files

- PR #467: Add missing fastmath flags from LLVM 7

- PR #460: LLVM 7 changed memset intrinsic signature, adjust it

## v0.28.0 (Mar 12, 2019)

This release adds a number of community contributed features, including support for vector types, as well as atomic loads and stores.

- PR #322: Adding Vector Type

- PR #389: Add symbols from static object files

- PR #417: Add support for atomic loads/stores

- PR #422: Normalize replace_* behaviour and add docs

- PR #426: Fix pickling of IR functions and add tests

- PR #444: Setup manylinux1 buildscripts and CI

- PR #446: Document need for -p1 argument to patch command

- PR #448: Fix “SyntaxWarning: invalid escape sequence d”

- PR #449: Consolidate the two vector type PRs

- PR #452: Some adjustments to pr426

- PR #454: Truncate long label names when adding label suffix.

- PR #458: Add changelog info about v0.27.1

## v0.27.1 (Feb 1, 2019)

Bugfix release for invalid wheel hash for OSX packages. No change to source code.

## v0.27.0 (Dec 28, 2018)

This release updates llvmlite to LLVM 7. Note that LLVM 7.0.0 contains a critical bug that is resolved with a patch included in the llvmdev conda package recipe. The final release of LLVM 7.0.1 may also resolve the issue.

- PR #434: Add another thread for RPi builds.

- PR #430: llvm lld integration, merge #428

- PR #428: Build LLD as part of the llvmdev package

- PR #413: Set up CI with Azure Pipelines

- PR #412: LLVM 7 support

## v0.26.0 (Nov 27, 2018)

The primary new features in this release is support for generation of Intel JIT events, which makes profiling of JIT compiled code in Intel VTune possible. This release also contains some minor build improvements for ARMv7, and some small fixes.

LLVM 7 support was originally slated for this release, but had to be delayed after some issues arose in testing. LLVM 6 is still required for llvmlite.

- PR #409: Use native cmake on armv7l

- PR #407: Throttle thread count for llvm build on armv7l.

- PR #403: Add shutdown detection to ObjectRef __del__ method.

- PR #400: conda recipe: add make as build dep

- PR #399: Add get_element_offset to TargetData

- PR #398: Fix gep method call on Constant objects

- PR #395: Fix typo in irbuilder documentation

- PR #394: Enable IntelJIT events for LLVM for VTune support

## v0.25.0 (Sep 18, 2018)

This release adds support for the FMA instruction, and has some documentation and build improvements. Starting with this release, we are including ARMv8 (AArch64) testig in our CI process.

- PR #391: Fix broken win32 py2.7 build.

- PR #387: protect against empty features in list

- PR #384: Read CMAKE_GENERATOR which conda-build sets

- PR #382: rewrite of install instructions, calling out LLVM build challenges

- PR #380: Add FMA intrinsic support

- PR #379: ARM aarch64 test on jetson tx2

- PR #378: add slack, drop flowdock

## v0.24.0 (Jul 6, 2018)

This release adds support for Python 3.7 and fixes some build issues. It also contains an updated SVML patch for the llvmdev package that works around some vectorization issues. It also adds a selective LLVM 6.0.1 llvmdev build for the ppc64le architecture.

- PR #374: Fix up broken patch selector

- PR #373: Add long description from readme

- PR #371: LLVM 6.0.1 build based on RC and fixes for PPC64LE

- PR #369: Recipe fixes for Conda Build 3

- PR #363: Workaround for incorrect vectorization factor computed for SVML functions

- PR #356: fix build on OpenBSD.

- PR #351: Python 3.7 compat: Properly escape repl in re.sub

## v0.23.2 (Jun 1, 2018)

This is a bug fix release to assist in addressing a critical Numba issue that can affect users who download llvmlite packages from sources other than PyPI (pip), Anaconda, or Intel Python: https://github.com/numba/numba/issues/3006

Support for SVML is now detected at compile time and baked into a function that is exposed by llvmlite. This function can be queried at runtime to find out if SVML is supported by the LLVM that llvmlite was compiled against, code generation paths can then be adjusted accordingly.

The following PRs are closed in this release:

- PR #361: Add SVML detection and a function to declare support.

## v0.23.1 (May 17, 2018)

This is a minor patch release that includes no code changes. It is issued to fix a couple of problems with the build recipes for llvmdev (on which llvmlite relies).

The following PRs are closed in this release:

- PR #353: PR Fix llvmdev build recipe.

- PR #348: llvmdev: enhancements to conda recipe

## v0.23.0 (Apr 24, 2018)

In this release, we upgrade to LLVM 6. Two LLVM patches are added:

> 1. A patch to fix LLVM bug (https://bugs.llvm.org/show_bug.cgi?id=37019) that causes undefined behavior during CFG printing.

> 2. A patch to enable Intel SVML auto-vectorization of transcendentals.

The following PRs are closed in this release:

- PR #343: Fix undefined behavior bug due to Twine usage in LLVM

- PR #340: This moves llvmlite to use LLVM 6.0.0 as its backend.

- PR #339: Add cttz & ctlz

- PR #338: Add 3 Bit Manipulation Intrinsics

- PR #330: Add support for LLVM fence instruction

- PR #326: Enable Intel SVML-enabled auto-vectorization for all the

    transcendentals

## v0.22.0 (Feb 15, 2018)

In this release, we have changed the locking strategy that protects LLVM from race conditions. Before, the llvmlite user (like Numba) was responsible for this locking. Now, llvmlite imposes a global thread lock on all calls into the LLVM API. This should be significantly less error prone. Future llvmlite releases may manually exempt some functions from locking once they are determined to be thread-safe.

The following PRs are closed in this release:

- PR#318: Ensuring threadsafety in concurrent usage of LLVM C-API

- PR#221: Add all function/return value attributes from LLVM 3.9

- PR#304: Expose support for static constructors/destructors

## v0.21.0 (Dec 6, 2017)

In this release, we upgrade to LLVM 5. Our build scripts now use conda-build 3. For our prebuilt binaries, GCC 7 toolchain is used on unix-like systems and the OSX minimum deployment target is 10.9.

The following PRs are closed in this release:

- PR #315: Updates for conda build 3.

- PR #307: Fixes for LLVM5.

- PR #306: Working towards LLVM 5.0 support.

## v0.20.0 (Sep 6, 2017)

Beginning with this minor release, we support wheels for Linux, OSX and Windows. Pull requests related to enabling wheels are #294, #295, #296 and #297. There are also fixes to the documentation (#283 and #289).

## v0.19.0 (Jul 6, 2017)

This is a minor release with the following fixes.

- PR #281, Issue #280: Fix GEP addrspace issue

- PR #279: Fix #274 addrspace in gep

- PR #278: add Readthedocs badge

- PR #275: Add variables to pass through when doing conda-build

- PR #273: Fix the behavior of module.get_global

- PR #272: cmpop contains comparison type, not lhs

- PR #268, Fix #267: Support packed struct

The following are CI build related changes:

- PR #277: Add pass through gcc flags for llvmdev

- PR #276: Remove jenkins build scripts

## v0.18.0 (May 4, 2017)

This is a minor release that fixes several issues (#263, #262, #258, #237) with the wheel build. In addition, we have minor fixes for running on PPC64LE platforms (#261). And, we added CI testing against PyPy (#253).

## v0.17.1 (Apr 12, 2017)

This is a bugfix release that addresses issue #258 that our LLVM binding shared library is missing from the wheel builds.

## v0.17.0 (Apr 9, 2017)

In this release, we are upgrading to LLVM 4.0. We are also starting to provide wheel packages for 64-bit Linux platforms (manylinux).

Fixes:

- Issue #249, PR #250: Disable static linking of libstdc++ by default.

Enhancements:

- PR #246: Add requirements.txt for pip dependency resolving

- PR #238: LLVM 4.0

- PR #222: Enable wheel builds

## v0.16.0 (Feb 16, 2017)

API changes:

- Switched from LLVM 3.8 to 3.9

- `TargetData.add_pass` is removed in LLVM 3.9.

Enhancements:

- PR #239: Enable fastmath flags

- PR #233: Updates for llvm3.9.1

- PR #199: Update for changes in LLVM 3.9

Fixes:

- PR #236: Fix metadata with long value

- PR #231: Fix setup.py for Python2.7 so that pip auto installs dependencies

- PR #226: Fix get_host_cpu_features() so that it fails properly

## v0.15.0 (Dec 20, 2016)

Enhancements:

- PR #213: Add partial LLVM bindings for ObjectFile.

- PR #215: Add inline assembly helpers in the builder.

- PR #216: Allow specifying alignment in alloca instructions.

- PR #219: Remove unnecessary verify in module linkage.

Fixes:

- PR #209, Issue #208: Fix overly restrictive test for library filenames.

## v0.14.0 (Oct 17, 2016)

Enhancements:

- PR #104: Add binding to get and view function control-flow graph.

- PR #210: Improve llvmdev recipe.

- PR #212: Add initializer for the native assembly parser.

## v0.13.0 (Aug 24, 2016)

Enhancements:

- PR #176: Switch from LLVM 3.7 to LLVM 3.8.

- PR #191: Allow setting the alignment of a global variable.

- PR #198: Add missing function attributes.

- PR #160: Escape the contents of metadata strings, to allow embedding any characters.

- PR #162: Add support for creating debug information nodes.

- PR #200: Improve the usability of metadata emission APIs.

- PR #200: Allow calling functions with metadata arguments (such as `@llvm.dbg.declare`).

Fixes:

- PR #190: Suppress optimization remarks printed out in some cases by LLVM.

- PR #200: Allow attaching metadata to a `ret` instruction.

## v0.12.1 (Jul 12, 2016)

New release to fix packages on PyPI. Same as v0.12.0.

## v0.12.0 (Jul 6, 2016)

Enhancements:

- PR #179: Let llvmlite build on armv7l Linux.

- PR #161: Allow adding metadata to functions.

- PR #163: Allow emitting fast-math `fcmp` instructions.

- PR #159: Allow emitting verbose assembly in TargetMachine.

Fixes:

- Issue #177: Make setup.py compatible with `pip install`.

## v0.11.0 (May 19, 2016)

Enhancements:

- PR #175: Check LLVM version at build time

- PR #169: Default initializer for non-external global variable

- PR #168: add ir.Constant.literal_array()

## v0.10.0 (Mar 31, 2016)

Enhancements:

- PR #146: Improve `setup.py clean` to wipe more leftovers.

- PR #135: Remove some llvmpy compatibility APIs.

- PR #151: Always copy TargetData when adding to a pass manager.

- PR #148: Make errors more explicit on loading the binding DLL.

- PR #144: Allow overriding `-flto` in Linux builds.

- PR #136: Remove Python 2.6 and 3.3 compatibility.

- Issue #131: Allow easier creation of constants by making type instances callable.

- Issue #130: The test suite now ensures the runtime DLL dependencies are within a certain expected set.

- Issue #121: Simplify build process on Unix and remove hardcoded linking with LLVMOProfileJIT.

- Issue #125: Speed up formatting of raw array constants.

Fixes:

- PR #155: Properly emit IR for metadata null.

- PR #153: Remove deprecated uses of `TargetMachine::getDataLayout()`.

- PR #156: Move personality from LandingPadInstr to FunctionAttributes. It was moved in LLVM 3.7.

- PR #149: Implement LLVM scoping correctly.

- PR #141: Ensure no CMakeCache.txt file is included in sdist.

- PR #132: Correct constant in `llvmir.py` example.

## v0.9.0 (Feb 29, 2016)

Enhancements:

- PR #73: Add get_process_triple() and get_host_cpu_features()

- Switch from LLVM 3.6 to LLVM 3.7. The generated IR for some memory operations has changed.

- Improved performance of IR serialization.

- Issue #116: improve error message when the operands of a binop have differing types.

- PR #113: Let Type.get_abi_{size,alignment} not choke on identified types.

- PR #112: Support non-alphanumeric characters in type names.

Fixes:

- Remove the libcurses dependency on Linux.

## v0.8.0 (Oct 23, 2015)

- Update LLVM to 3.6.2

- Add an align parameter to IRBuilder.load() and IRBuilder.store().

- Allow setting visibility, DLL storageclass of ValueRef

- Support profiling with OProfile

## v0.7.0 (Aug 31, 2015)

- PR #88: Provide hooks into the MCJIT object cache

- PR #87: Add indirect branches and exception handling APIs to ir.Builder.

- PR #86: Add ir.Builder APIs for integer arithmetic with overflow

- Issue #76: Fix non-Windows builds when LLVM was built using CMake

- Deprecate .get_pointer_to_global() and add .get_function_address() and .get_global_value_address() in ExecutionEngine.

## v0.6.0 (Jun 30, 2015)

Enhancements:

- Switch from LLVM 3.5 to LLVM 3.6. The generated IR for metadata nodes has slightly changed, and the “old JIT” engine has been remove (only MCJIT is now available).

- Add an optional flags argument to arithmetic instructions on IRBuilder.

- Support attributes on the return type of a function.

## v0.5.1 (Jun 8, 2015)

Fixes:

- Fix implicit termination of basic block in nested if_then()

## v0.5.0 (May 27, 2015)

New documentation hosted at http://llvmlite.pydata.org

Enhancements:

- Add code-generation helpers from numba.cgutils

- Support for memset, memcpy, memmove intrinsics

Fixes:

- Fix string encoding problem when round-triping parse_assembly()

## v0.4.0 (Mar 30, 2015)

Enhancements:

- Add Module.get_global()

- Renamd Module.global_variables to Module.global_values

- Support loading library parmanently

- Add Type.get_abi_alignment()

Fixes:

- Expose LLVM version as a tuple

Patched LLVM 3.5.1: Updated to 3.5.1 with the same ELF relocation patched for v0.2.2.

## v0.2.2 (Jan 29, 2015)

Enhancements:

- Support for addrspacescast

- Support for tail call, calling convention attribute

- Support for IdentifiedStructType

Fixes:

- GEP addrspace propagation

- Various installation process fixes

Patched LLVM 3.5: The binaries from the numba binstar channel use a patched LLVM3.5 for fixing a LLVM ELF relocation bug that is caused by the use of 32-bit relative offset in 64-bit binaries. The problem appears to occur more often on hardened kernels, like in CentOS. The patched source code is available at: https://github.com/numba/llvm-mirror/releases/tag/3.5p1

## v0.2.0 (Dec 16, 2014)

This is the first official release. It contains a few feature additions and bug fixes. It meets all requirements to replace llvmpy in numba and numbapro.

## v0.1.0 (Nov 13, 2014)

This is the first release. This is released for beta testing llvmlite and numba before the official release.